<template>
  <div class="item-select-dlg dialog-box">
    <el-form
      ref="formSetTourismTravelNotesFile"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormSetTourismTravelNotesFile()" @reset="resetFormSetTourismTravelNotesFile">
        <template #operation>
          <el-button type="primary" @click="onSubmit" :size="layoutStore.defaultFormItemSize">
            确定
          </el-button>
        </template>
      </filter-box>
    </el-form>
    <table-box
      ref="tourTourismTravelNotesFile"
      class="main-box"
      :data="tourTourismTravelNotesFileWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((tourTourismTravelNotesFileWidgetCurrentPage - 1) * tourTourismTravelNotesFileWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="false"
      @sort-change="tourTourismTravelNotesFileWidget.onSortChange"
      @refresh="tourTourismTravelNotesFileWidget.refreshTable()"
      @radio-select-change="onSelectChange"
    >
      <vxe-column title="" type="radio" align="center" :width="80" />
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="tourTourismTravelNotesFileWidgetTotalCount"
            :current-page="tourTourismTravelNotesFileWidgetCurrentPage"
            :page-size="tourTourismTravelNotesFileWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="tourTourismTravelNotesFileWidget.onCurrentPageChange"
            @size-change="tourTourismTravelNotesFileWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formSetTourismTravelNotesFile',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { TourTourismTravelNotesFileData } from '@/api/generated/tourTourismTravelNotesFileController';
import { TourTourismTravelNotesFileController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const pps = withDefaults(
  defineProps<{
    modelValue: TourTourismTravelNotesFileData[];
    subPage?: number | string | boolean;
    props: {
      label: string;
      value: string;
    };
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    modelValue: () => [],
    props: () => {
      return {
        label: 'name',
        value: 'id',
      };
    },
    dialog: undefined,
  },
);
// 选中数据
const dialogSelectItems = ref<TourTourismTravelNotesFileData>();

const onCancel = () => {
  if (pps.dialog) {
    pps.dialog.cancel();
  }
};

const onSubmit = () => {
  if (pps.dialog) {
    pps.dialog.submit(dialogSelectItems.value);
  }
};

/**
 * 重置过滤值
 */
const resetFormSetTourismTravelNotesFile = () => {
  refreshFormSetTourismTravelNotesFile();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormSetTourismTravelNotesFile();
};
/**
 * 表格组件数据获取函数，返回Promise
 */
const loadTourTourismTravelNotesFileWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
  };
  return new Promise((resolve, reject) => {
    TourTourismTravelNotesFileController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
      nextTick(() => {
        setTableSelectRow();
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadTourTourismTravelNotesFileVerify = () => {
  return true;
};
// 表格组件表格组件参数
const tourTourismTravelNotesFileOptions: TableOptions<TourTourismTravelNotesFileData> = {
  loadTableData: loadTourTourismTravelNotesFileWidgetData,
  verifyTableParameter: loadTourTourismTravelNotesFileVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const tourTourismTravelNotesFile = ref();
const tourTourismTravelNotesFileWidget = useTable(tourTourismTravelNotesFileOptions);
const {
  dataList: tourTourismTravelNotesFileWidgetDataList,
  currentPage: tourTourismTravelNotesFileWidgetCurrentPage,
  pageSize: tourTourismTravelNotesFileWidgetPageSize,
  totalCount: tourTourismTravelNotesFileWidgetTotalCount,
} = tourTourismTravelNotesFileWidget;
const setTableSelectRow = () => {
  if (tourTourismTravelNotesFile.value == null || !Array.isArray(tourTourismTravelNotesFileWidget.dataList.value))
    return;
  setTimeout(() => {
    let selectRow = findItemFromList(
      tourTourismTravelNotesFileWidget.dataList.value,
      (dialogSelectItems.value || {})[pps.props.value],
      pps.props.value,
    );
    tourTourismTravelNotesFile.value.getTableImpl().setRadioRow(selectRow);
  }, 50);
};
const refreshFormSetTourismTravelNotesFile = () => {
  // 重新获取数据组件的数据
  tourTourismTravelNotesFileWidget.refreshTable();
};
const onSelectChange = (row?: TourTourismTravelNotesFileData) => {
  dialogSelectItems.value = row;
};

const formInit = () => {
  refreshFormSetTourismTravelNotesFile();
};

onMounted(() => {
  if (Array.isArray(pps.modelValue) && pps.modelValue.length > 0) {
    dialogSelectItems.value = {
      ...pps.modelValue[0],
    };
  }
  formInit();
});
</script>

<style scoped>
.main-box {
  flex-grow: 1;
}
</style>
